<template>
  <q-layout view="lHh Lpr lFf">
    <q-header elevated>
      <q-toolbar>
        <q-btn
          flat
          dense
          round
          icon="menu"
          aria-label="Menu"
          v-on:click="leftDrawerOpen = !leftDrawerOpen"
        />

        <q-toolbar-title>
          Easy Quiz
        </q-toolbar-title>

        <div>
          <q-btn
            flat
            v-if="loggedIn"
            v-bind:label="userName"
            icon="settings"
            to="/home/settings"
          />
          <q-btn
            flat
            name="login"
            v-bind:label="loggedIn ? 'Cerrar Sesión' : 'Iniciar Sesión'"
            icon-right="arrow_forward"
            v-on:click="loggedIn ? logOut() : logIn()"
          />
        </div>
      </q-toolbar>
    </q-header>

    <q-drawer
      v-model="leftDrawerOpen"
      show-if-above
      bordered
      content-class="bg-grey-1"
    >
      <q-list>
        <q-item-label
          header
          class="text-grey-8"
        >
          Navegación
        </q-item-label>
        <EssentialLink
          v-for="route in route.children"
          v-bind:key="route.path"
          v-bind="route"
        />
      </q-list>
    </q-drawer>

    <q-page-container>
      <router-view />
    </q-page-container>
  </q-layout>
</template>

<script>
import routes from '../router/routes'
import LoginDialog from 'components/login/LoginDialog.vue'
import { mapGetters } from 'vuex'

export default {
  name: 'MainLayout',
  components: {
    EssentialLink: () => import('../components/EssentialLink')
  },
  data () {
    return {
      leftDrawerOpen: false
    }
  },
  computed: {
    ...mapGetters({
      loggedIn: 'auth/loggedIn',
      userName: 'auth/getName'
    }),
    route () {
      let route = null
      Object.keys(routes).some(key => {
        if (!this.loggedIn && routes[key].path === '/') {
          route = routes[key]
          return true
        } else if (this.loggedIn && routes[key].path === '/app') {
          route = routes[key]
          return true
        }
      })
      return route
    }
  },
  methods: {
    logOut () {
      this.$store.dispatch('auth/logOut')
      this.$router.go('/')
    },
    logIn () {
      this.$q.dialog({
        component: LoginDialog,
        parent: this
      })
    }
  }
}
</script>
